## nvidia-graphics-drivers-legacy-96xx 96.43.18

=== debian/changelog ===
nvidia-graphics-drivers-legacy-96xx (96.43.18-2) unstable; urgency=low

  [ Andreas Beckmann ]
  * Synchronize packaging with nvidia-graphics-drivers 195.36.31-4 and
    nvidia-graphics-drivers-legacy-173xx 173.14.27-2:
    - Remove /emul directories if empty after removing old NVIDIA files in
      the nvidia-glx-legacy-96xx-ia32 postinst.
    - debian/*.postinst(configure): abort early if DPKG_MAINTSCRIPT_PACKAGE is
      not set (usually if called from dpkg-reconfigure, see #560317).
    - nvidia-glx-legacy-96xx{,-ia32}: print warning in postinst if unknown
      /usr/lib{,32}/libGL.so.*.* exist.
    - nvidia-glx-legacy-96xx: depend on xorg-video-abi-6.0 as suggested by
      Xorg maintainers.
    - nvidia-kernel-legacy-96xx-source: lower Recommends:
      nvidia-glx-legacy-96xx to Suggests to avoid pulling
      nvidia-kernel-legacy-96xx-dkms into the system before the user had a
      chance to build a module.
    - Add new patch 2.6.36-ioctl.patch to fix module build for kernel 2.6.36.
    - Add changelog entries missing due to concurrent development: 1.0.9625-2
      (experimental), 1.0.9625-1 (experimental) and 1.0.7174-4 (unstable).
    - Stop shipping libGL.so symlinks and handling alternatives involving
      them.
    - Stop shipping NVIDIA's copy of the OpenGL headers, depend on
      libgl1-mesa-dev instead.  NVIDIA will stop distributing the headers
      starting with the 260.xx release and recommends to use the official
      ones.
    - Transition from nvidia-glx-legacy-96xx-dev directly to libgl1-mesa-dev.
    - Drop the libgl1-nvidia-legacy-96xx-dev package (and stop shipping
      libXvMCNVIDIA.a).
    - Add myself to Uploaders.

 -- Andreas Beckmann <debian@abeckmann.de>  Sun, 26 Sep 2010 07:09:00 +0200

nvidia-graphics-drivers-legacy-96xx (96.43.18-1) unstable; urgency=low

  [ Andreas Beckmann ]
  * new upstream release (closes: #523941)
  * add missing Build-Depends: libxext6, fixes FTBFS
  * synchronize packaging with nvidia-graphics-drivers 195.36.31-3 and
    nvidia-graphics-drivers-legacy-173xx 173.14.27-1
    - new uploaders
    - source format 3.0 (quilt)
    - remove old cruft
    - clean up and simplify packaging
    - use substvars instead of generating debian/control
    - do not ship generated files in the source package
    - clean up dependencies in debian/control (closes: #449112)
    - drop ancient patches and unused patch systems
    - overhaul the kernel module build system (closes: #396384, #499636)
      (closes: #510960, #541798, #476643)
    - update conftest.h and add patches for module build (closes: #574420)
      (closes: #534867, #542827, #540838)
    - add dkms support
    - overhaul debian/rules: use dh(1) and many more changes
    - add functional watch file
    - overhaul copyright, READMEs and other documentation
    - overhaul maintainer scripts (closes: #425353)
    - drop init script and defaults file (closes: #426250, #490847)
    - use a dpkg trigger to create the libGL.so symlink (closes: #504661)
    - nvidia-glx now provides xserver-xorg-video-6
    - add Conflicts: nvidia-glx-legacy that was never really taken care of
    - fix the shlibs and symbols files
    - split the nvidia-glx-legacy-96xx{,-ia32} packages, moving the shared
      libraries to libgl1-nvidia-legacy-96xx-glx{,-ia32}
    - rename nvidia-glx-legacy-96xx-dev to libgl1-nvidia-legacy-96xx-dev
    - add Provides/Conflicts for the new virtual packages nvidia-glx{,-ia32},
      libgl1-nvidia-glx{,-ia32}, libgl1-nvidia-dev
    - use alternatives for libGL.so.1, libGL.so, libglx.so and let the
      lib{gl1,glx}-nvidia-alternatives{,-ia32} packages (not built from this
      source package) handle the diversions
    - add Conflicts: fglrx-driver, fglrx-glx, fglrx-glx-ia32
    - add Conflicts: with badly sorting obsolete packages
      linux-{image,headers}-2.6.32-trunk-*
    - nvidia-glx-legacy-96xx: install HTML variant of the README
    - update to Standards-Version: 3.9.1
    - update to debhelper compat level 8
    - drop LEGACY part from virtual package name nvidia-kernel-NVIDIAVERSION
    - lots of small fixes and cleanup
    - extract nv-kernel.ids from nv-kernel.o
  * adjust version numbers in maintainer scripts
  * update nv-kernel.ids
  * refresh patches
  * update symbols files
  * update lintian overrides
  * only list the GPUs supported in this legacy series for the last time in
    the long description, do not list models in the libgl1-nvidia* packages

 -- Russ Allbery <rra@debian.org>  Fri, 03 Sep 2010 17:16:48 -0700

nvidia-graphics-drivers-legacy-96xx (96.43.16-1) unstable; urgency=low

  * new upstream (closes:  #534131, #545228)

 -- Randall Donald <rdonald@debian.org>  Tue, 16 Mar 2010 20:21:46 -0700

nvidia-graphics-drivers-legacy-96xx (96.43.14-2) unstable; urgency=low

  * divert ia32-libs (closes: #559474)

 -- Randall Donald <rdonald@debian.org>  Sun, 13 Dec 2009 18:20:15 -0800

nvidia-graphics-drivers-legacy-96xx (96.43.14-1) unstable; urgency=low

  * New Upstream
  * Support latest xserver (closes: #523806, #523853, #547463, #560013)
  * add lsb headers (closes: #549991)
  * remove libGL.so from -ia32 (closes: #559474)

 -- Randall Donald <rdonald@debian.org>  Sat, 12 Dec 2009 14:11:22 -0800

nvidia-graphics-drivers-legacy-96xx (96.43.13+1-1) unstable; urgency=low

  [ Len Sorensen ]
  * New upstream release supporting newer kernels.

  [ Randall Donald ]
  * Make sure both kernel modules are included
  * transition to lib32

 -- Randall Donald <rdonald@debian.org>  Thu, 15 Oct 2009 15:34:31 -0700

nvidia-graphics-drivers-legacy-96xx (96.43.13-0.1) unstable; urgency=low

  * Non-maintainer upload.
  * New upstream release:
    - Compatibility with recent (>=2.6.28) linux kernels
      (closes: #510961)
  * Updated x86 pkg0 to pkg1.

 -- Yaroslav Halchenko <debian@onerussian.com>  Thu, 23 Jul 2009 13:19:49 -0400

nvidia-graphics-drivers-legacy-96xx (96.43.11-0.1) UNRELEASED; urgency=low

  * New upstream release (personal packaging):

